Index: libabac/abac_m64.c
===================================================================
--- libabac/abac_m64.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_m64.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -1,3 +1,2 @@
-
 
 #include <stdio.h>
@@ -5,5 +4,5 @@
 #include <string.h>
 
-static int debug=1;
+static int debug=0;
 char* abac_decode_string(char *);
 
@@ -62,4 +61,5 @@
     if((len/3)*3 != len) {
         hops=(len/3)+1;
+        olen=hops*3;
         orig_string=malloc(sizeof(char)*olen); 
         strcpy(orig_string,string);
@@ -68,7 +68,7 @@
         } else {
         hops=len/3;
+        olen=hops*3;
         orig_string=strdup(string);
     }
-    olen=hops*3;
     nlen=(olen*4/3 +1);
     new_string = (char *) malloc(sizeof(char)*nlen);
@@ -76,4 +76,7 @@
     inbufptr=orig_string;
     outbufptr=new_string;
+    if(debug) {
+       printf("sizeof string %d\n", len);
+    }
 
     int idx=0;
Index: libabac/abac_param.c
===================================================================
--- libabac/abac_param.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_param.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -2,4 +2,7 @@
 /***********************************************************
    abac_param.c
+
+ dterm=data term of rt1
+ param is a kind of dterm
 ***********************************************************/
 #include <assert.h>
@@ -7,4 +10,5 @@
 #include <stdio.h>
 #include <string.h>
+#include <ctype.h>
 
 #include "abac_list.h"
@@ -13,9 +17,46 @@
 #include "abac_pl.h"
 
+typedef enum _termtype {
+    e_TERM_INTEGER = 1,
+    e_TERM_URN = 2,
+    e_TERM_FLOAT = 3,
+    e_TERM_BOOLEAN = 4,
+    e_TERM_STRING = 5,
+    e_TERM_TIME = 6,
+    e_TERM_PRINCIPAL = 7,
+    e_TERM_ANONYMOUS = 8
+} termtype_t;
+
+/* termname[dtermtype] */
+static char *const termname[] =
+{
+  "badterm",
+  "integer",
+  "urn",
+  "float",
+  "boolean",
+  "string",
+  "time" ,
+  "principal",
+  "anonymous",
+  0
+};
+static int termname_cnt=8;
+
+typedef enum _condtype_t {
+    e_COND_ROLE = 1,
+    e_COND_OSET = 2
+} condtype_t;
+
 struct _abac_condition_t {
+    int type;
     char *string;
+    union {
+       abac_role_t *of_role;
+       abac_oset_t *of_oset;
+    };
 };
 
-struct _abac_param_t {
+struct _abac_term_t {
     int type;
     char *name;
@@ -28,10 +69,68 @@
 };
 
+
 /******************************************************************/
-
-static abac_condition_t *abac_condition_new(char *condition)
-{
-     abac_condition_t *ptr=abac_xmalloc(sizeof(abac_condition_t));
-     ptr->string=condition;
+char *abac_term_name(abac_term_t *term)
+{
+    return term->name;
+}
+
+abac_condition_t *abac_term_constraint(abac_term_t *term)
+{
+    return term->constraint;
+}
+
+char *abac_term_type(int i)
+{
+    return termname[i];
+}
+
+int abac_term_is_time_type(int i)
+{
+    if (i == e_TERM_TIME) 
+       return 1;
+    return 0;
+}
+
+int abac_term_is_string_type(int i)
+{
+    if (i == e_TERM_STRING) 
+       return 1;
+    return 0;
+}
+
+int abac_term_is_integer_type(int i)
+{
+    if (i == e_TERM_INTEGER) 
+       return 1;
+    return 0;
+}
+
+int abac_term_is_urn_type(int i)
+{
+    if (i == e_TERM_URN) 
+       return 1;
+    return 0;
+}
+
+int abac_verify_term_type(char *type) {
+    int i;
+
+    if (type == NULL)
+        return 0;
+
+    for (i = 1; i <= termname_cnt ; i++)
+        if(strcmp(type,termname[i])==0)
+            return i;
+    return 0;
+}
+
+static abac_condition_t *abac_condition_new(int type,char* condstr,void *cptr)
+{
+     abac_condition_t *ptr=
+             (abac_condition_t *)abac_xmalloc(sizeof(abac_condition_t));
+     ptr->type=type;
+     ptr->string=strdup(condstr);
+     ptr->of_role=cptr;
      return ptr;
 }
@@ -39,22 +138,39 @@
 static void abac_condition_free(abac_condition_t *ptr)
 {
-     free(ptr->string);
+     if(ptr->type == e_COND_OSET)
+         abac_oset_free(ptr->of_oset);
+         else abac_role_free(ptr->of_role);
+     if(ptr->string) free(ptr->string);
      free(ptr);
 }
 
-abac_param_t *abac_param_new(int type, char *name, char *cond)
+/* always add p to the name except if its a variable and needed */
+abac_term_t *abac_term_new(int type, char *name, char *cond, void *cptr)
 {
      abac_condition_t *constraint=NULL;
      if (cond) {
-         constraint=abac_condition_new(cond);
+         if(type==e_TERM_PRINCIPAL)
+             constraint=abac_condition_new(e_COND_ROLE,cond,cptr);
+             else
+                 constraint=abac_condition_new(e_COND_OSET,cond,cptr);
      }
-     abac_param_t *ptr=abac_xmalloc(sizeof(abac_param_t));
+     abac_term_t *ptr=abac_xmalloc(sizeof(abac_term_t));
      ptr->type=type;
-     ptr->name=name;
+     /* add p to time term if needed and not a variable */
+     if((!constraint) && 
+              abac_term_is_time_type(type) && isdigit(name[0])) {
+         char *tmp;
+         asprintf(&tmp,"p%s",name);
+         ptr->name=tmp;
+         free(name);
+         } else {
+             ptr->name=strdup(name);
+     }
+
      ptr->constraint=constraint;
      return ptr;
 }
 
-void abac_param_free(abac_param_t *ptr)
+void abac_term_free(abac_term_t *ptr)
 {
     if(ptr->constraint) {
@@ -65,9 +181,9 @@
 }
 
-abac_param_list_t *abac_param_list_new(abac_param_t *param)
+abac_param_list_t *abac_param_list_new(abac_term_t *term)
 {
     abac_param_list_t *ptr=abac_xmalloc(sizeof(abac_param_list_t));
     ptr->list=abac_list_new();
-    abac_list_add(ptr->list, param);
+    abac_list_add(ptr->list, term);
     return ptr;
 }
@@ -76,7 +192,7 @@
 {
     abac_list_t *list=ptr->list;
-    abac_param_t  *cur;
+    abac_term_t  *cur;
     abac_list_foreach(list, cur,
-           abac_param_free(cur);
+           abac_term_free(cur);
     );
     abac_list_free(list);
@@ -84,12 +200,12 @@
 }
 
-abac_param_list_t *abac_param_list_add_param(abac_param_list_t *ptr, abac_param_t *param)
+abac_param_list_t *abac_param_list_add_term(abac_param_list_t *ptr, abac_term_t *term)
 {
     abac_list_t *list=ptr->list;
-    abac_list_add(list, param);
+    abac_list_add(list, term);
     return ptr;
 }
 
-abac_param_t *abac_param_add_constraint(abac_param_t *ptr, abac_condition_t *cond)
+abac_term_t *abac_term_add_constraint(abac_term_t *ptr, abac_condition_t *cond)
 {
     if(ptr->constraint) {
@@ -101,7 +217,25 @@
 
 /* name or name:cond */
-static char *abac_param_string_with_condition(abac_param_t *ptr)
+static char *abac_term_string_with_condition(abac_term_t *ptr)
 {
     char *tmp=NULL;
+    char *cond=NULL;
+    char *name=ptr->name;
+    int len=strlen(name)+1;
+    if(ptr->constraint) {
+       cond=ptr->constraint->string;
+       len=len+strlen(cond)+1;
+    }
+    tmp = abac_xmalloc(len);
+    if(cond)
+       sprintf(tmp,"%s:%s", name, cond);
+       else
+           sprintf(tmp,"%s", name);
+    return tmp;
+}
+
+/* len of name or name:cond */
+static int abac_term_len_with_condition(abac_term_t *ptr)
+{
     char *cond=NULL;
     char *name=ptr->name;
@@ -111,34 +245,27 @@
        len=len+strlen(cond)+1;
     }
-    tmp = abac_xmalloc(len);
-    if(cond)
-       sprintf(tmp,"%s:%s", name, cond);
-       else
-           sprintf(tmp,"%s", name);
-    return tmp;
-}
-
-/* len of name or name:cond */
-static int abac_param_len_with_condition(abac_param_t *ptr)
-{
-    char *cond=NULL;
-    char *name=ptr->name;
-    int len=strlen(name);
-    if(ptr->constraint) {
-       cond=ptr->constraint->string;
-       len=len+strlen(cond)+1;
-    }
     return len;
 }
 
 /* just name */
-static char *abac_param_string(abac_param_t *ptr)
-{
+static char *abac_term_string(abac_term_t *ptr)
+{
+    if(ptr->type == abac_verify_term_type("urn") ||
+              ptr->type == abac_verify_term_type("string") ) {
+        char *str;
+        asprintf(&str, "%s", ptr->name);
+        return str;
+    }
     return strdup(ptr->name);
 }
 
 /* just len of name */
-static int abac_param_len(abac_param_t *ptr)
-{
+static int abac_term_len(abac_term_t *ptr)
+{
+    /* including the 2 ' */
+    if(ptr->type == abac_verify_term_type("urn") ||
+              ptr->type == abac_verify_term_type("string") ) {
+        return strlen(ptr->name)+2; 
+    }
     return strlen(ptr->name);
 }
@@ -150,17 +277,17 @@
         return "";
 
-    abac_param_t  *cur;
+    abac_term_t  *cur;
     char *tmp;
     int len=0;
     /* collect up all the lens so can allocate once */
     abac_list_foreach(ptr->list, cur,
-           int l=abac_param_len_with_condition(cur);
+           int l=abac_term_len_with_condition(cur);
            len=len+l+1;
     );
-    tmp=abac_xmalloc(len * sizeof(char));
+    tmp=abac_xmalloc((len+1) * sizeof(char));
     /* collect up all the string */
     int first=1;
     abac_list_foreach(ptr->list, cur,
-           char *s=abac_param_string_with_condition(cur);
+           char *s=abac_term_string_with_condition(cur);
            if(first) {
                strcpy(tmp,s);
@@ -181,5 +308,5 @@
     if(list == NULL)
         return "";
-    abac_param_t  *cur;
+    abac_term_t  *cur;
     char *tmp;
     int len=0;
@@ -187,12 +314,12 @@
     abac_list_foreach(list, cur,
            // collect up the len
-           int l=abac_param_len(cur);
+           int l=abac_term_len(cur);
            len=len+l+1;
     );
-    tmp=abac_xmalloc(len * sizeof(char));
+    tmp=abac_xmalloc((len+1) * sizeof(char));
     /* collect up all the string */
     int first=1;
     abac_list_foreach(list, cur,
-           char *s=abac_param_string(cur);
+           char *s=abac_term_string(cur);
            if(first) {
                strcpy(tmp,s);
Index: libabac/abac_pl.c
===================================================================
--- libabac/abac_pl.c	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl.c	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -11,8 +11,4 @@
 #include "abac_pl_yap.h"
 
-#ifdef DEBUG_IT
-#include "abac_pl_yap_dbg.h"
-#endif
-
 #include "abac_util.h"
 #include "abac_verifier.h"
@@ -22,8 +18,4 @@
 struct _abac_context_t {
     abac_pl_t *pl;
-#ifdef DEBUG_IT
-/* this is just for debugging */
-    abac_pl_yap_dbg_t *dpl;
-#endif
 };
 
@@ -58,9 +50,4 @@
     abac_context_t *ctx = abac_xmalloc(sizeof(abac_context_t));
     ctx->pl = abac_pl_new();
-#ifdef DEBUG_IT
-    if (debug) {
-        ctx->dpl = abac_pl_yap_dbg_new();
-    } else ctx->dpl = NULL;
-#endif
     return ctx;
 }
@@ -71,7 +58,5 @@
 abac_context_t *abac_context_dup(abac_context_t *ctx) {
     assert(ctx != NULL);
-
     abac_context_t *dup = abac_xmalloc(sizeof(abac_context_t));
-
     return dup;
 }
@@ -85,8 +70,4 @@
 
     abac_pl_free(ctx->pl);
-#ifdef DEBUG_IT
-    if (ctx->dpl)
-        abac_pl_yap_dbg_free(ctx->dpl);
-#endif
     free(ctx);
 }
@@ -234,6 +215,6 @@
 abac_credential_t **abac_context_query(abac_context_t *ctx, char *role, char *principal, int *success) {
     abac_credential_t **credentials = NULL, *cur;
-
-    assert(ctx != NULL); assert(role != NULL); assert(principal != NULL); assert(success != NULL);
+    assert(ctx != NULL); assert(role != NULL);
+    assert(principal != NULL); assert(success != NULL);
 
     abac_stack_t *result = abac_pl_query(ctx->pl, role, principal);
@@ -261,5 +242,6 @@
     credentials[i] = NULL;
 
-    abac_stack_free(result);
+    if(result)
+        abac_stack_free(result);
 
     return credentials;
@@ -270,5 +252,27 @@
  */
 abac_credential_t **abac_context_credentials(abac_context_t *ctx) {
-    assert(ctx != NULL);
+    abac_credential_t **credentials = NULL, *cur;
+    assert(ctx != NULL);
+
+    abac_stack_t *result = abac_pl_credentials(ctx->pl);
+    int size = abac_stack_size(result);
+
+    // make the array (leave space to NULL terminate it)
+    //      n.b., even if the list is empty, we still return an array that
+    //            only contains the NULL terminator
+    credentials = abac_xmalloc(sizeof(abac_credential_t *) * (size + 1));
+    int i = 0;
+    if(size) {
+        while(i<size) { 
+            cur=(abac_credential_t *) abac_stack_pop(result);
+            /* if not in there yet, add into it */
+            credentials[i++] = cur;
+        } 
+    }
+    credentials[i] = NULL;
+
+    if(result)
+        abac_stack_free(result);
+    return credentials;
 }
 
@@ -287,10 +291,2 @@
 }
 
-#ifdef DEBUG_IT
-// for debugging only
-void abac_context_debug_run(abac_context_t *ctx) {
-    if (ctx) {
-        abac_pl_yap_dbg_run_can(ctx->dpl);
-    }
-}
-#endif
Index: libabac/abac_pl.h
===================================================================
--- libabac/abac_pl.h	(revision a9494ad1c5e523f94b0d172045537662de58fd54)
+++ libabac/abac_pl.h	(revision da5afdf4d61c978dbd17b9d6f20e5a45dcab870a)
@@ -9,8 +9,9 @@
 typedef struct _abac_credential_t abac_credential_t;
 typedef struct _abac_role_t abac_role_t;
+typedef struct _abac_oset_t abac_oset_t;
 typedef struct _abac_id_cert_t abac_id_cert_t;
 
 typedef struct _abac_condition_t abac_condition_t;
-typedef struct _abac_param_t abac_param_t;
+typedef struct _abac_term_t abac_term_t;
 typedef struct _abac_param_list_t abac_param_list_t;
 
@@ -75,4 +76,5 @@
 char *abac_role_linked_role(abac_role_t *role);
 char *abac_role_role_name(abac_role_t *role);
+char *abac_role_role_param_string(abac_role_t *role);
 char *abac_role_principal(abac_role_t *role);
 abac_list_t *abac_role_prereqs(abac_role_t *role);
@@ -82,13 +84,33 @@
 
 char *abac_role_attr_key(abac_role_t *head_role, abac_role_t *tail_role);
+char *abac_role_principal_cn(abac_role_t *role);
 
 /*
- * Operations on params.
+ * Operations on oset
  */
-abac_param_t *abac_param_new(int type, char *name, char *cond);
-void abac_param_free(abac_param_t *ptr);
-abac_param_list_t *abac_param_list_new(abac_param_t *param);
+char *abac_oset_principal_cn(abac_oset_t *oset);
+char *abac_oset_oset_name(abac_oset_t *oset);
+abac_param_list_t *abac_oset_oset_params(abac_oset_t *oset);
+int abac_oset_is_object(abac_oset_t *oset);
+char *abac_oset_object_cn(abac_oset_t *oset);
+char *abac_oset_linked_role(abac_oset_t *oset);
+abac_param_list_t *abac_oset_linked_role_params(abac_oset_t *oset);
+abac_list_t *abac_oset_prereqs(abac_oset_t *tail_oset);
+int abac_oset_is_intersection(abac_oset_t *tail_oset);
+abac_oset_t *abac_oset_intersection_new(char *name, abac_list_t *prereqs);
+abac_oset_t *abac_oset_oset_new(char *principal_name, char *oset_name);
+abac_oset_t *abac_oset_object_new(abac_term_t *object);
+abac_oset_t *abac_oset_linking_new(char *principal_name, char *linked_role_name, char *oset_name);
+
+/*
+ * Operations on term/params.
+ */
+abac_term_t *abac_term_new(int type, char *name, char *cond, void *cptr);
+void abac_term_free(abac_term_t *ptr);
+int abac_term_is_time_type(int);
+char *abac_term_name(abac_term_t *ptr);
+abac_param_list_t *abac_param_list_new(abac_term_t *term);
 abac_param_list_t *abac_param_list_free(abac_param_list_t *ptr);
-abac_param_list_t *abac_param_list_add_param(abac_param_list_t *, abac_param_t *param);
+abac_param_list_t *abac_param_list_add_term(abac_param_list_t *, abac_term_t *term);
 char* abac_param_list_string(abac_param_list_t *ptr);
 char* abac_param_list_string_with_condition(abac_param_list_t *ptr);
